#include "menu.h"
//-----------------------------------------------------------
void MainMenuProcess(void);
void BlinkItem(unsigned char ind);
void MainMenuItemProcess(unsigned char ind);
char str2[5];
//-----------------------------------------------------------
extern unsigned int tim_cnt;//  
static unsigned char i=0;

char str1[6][11]=
{
	"MM_1 \0",
	"MM_2 \0",
	"MM_3 \0",
	"MM_4 \0",
	"MM_5 \0",
	"EXIT \0"
};
MENU_StateTypeDef menu_state = MENU_STATE_IDLE;
MAIN_MENU_StateTypeDef main_menu_state = MAIN_MENU_STATE_IDLE;
//-----------------------------------------------------
void MenuProcess(void)
{
	switch (menu_state)
	{
		case MENU_STATE_IDLE: // 
			menu_state = MENU_STATE_WAIT;
			clearlcd();
			setpos(0,0);
			str_lcd("MENU");
			setpos(0,1);
			str_lcd("Press SELECT");
			break;
		case MENU_STATE_WAIT: //   
			if(button_state[Button_Select]&ST_UNPRESSURE)
			{
				SetButtonState(Button_Select,ST_LOCKED);
				ResetButtonState(Button_Select,ST_UNPRESSURE);
				SetButtonState(Button_Select,ST_PRESSURE);
				//  
				menu_state = MENU_STATE_MAIN;
			}
			break;
		case MENU_STATE_MAIN: //  
			main_menu_state = MAIN_MENU_STATE_IDLE;
			MainMenuProcess();
			break;
	}

	_delay_ms(50);
}
//-----------------------------------------------------
void MainMenuProcess(void)
{
	while (1)
	{
		switch (main_menu_state)
		{
			case MAIN_MENU_STATE_IDLE: //  
				setpos(0,0);
				for(i=0;i<3;i++)
				{
					str_lcd(str1[i]);
				}
				setpos(0,1);
				for(i=0;i<3;i++)
				{
					str_lcd(str1[i+3]);
				}
				_delay_ms(50);
				ResetButtonState(Button_Select,ST_LOCKED);
				main_menu_state = MAIN_MENU_STATE_WAIT;
				break;
			case MAIN_MENU_STATE_WAIT: //  
				if(button_state[Button_Right]&ST_UNPRESSURE)
				{
					SetButtonState(Button_Right,ST_LOCKED);
					ResetButtonState(Button_Right,ST_UNPRESSURE);
					SetButtonState(Button_Right,ST_PRESSURE);
					//  
					_delay_ms(50);
					ResetButtonState(Button_Right,ST_LOCKED);
					main_menu_state = MAIN_MENU_STATE_MM1_WAIT;
				}
				break;
			case MAIN_MENU_STATE_MM1_WAIT: //  1 
				BlinkItem(0);
				// 
				if(button_state[Button_Right]&ST_UNPRESSURE)
				{
					SetButtonState(Button_Right,ST_LOCKED);
					ResetButtonState(Button_Right,ST_UNPRESSURE);
					SetButtonState(Button_Right,ST_PRESSURE);
					//  
					_delay_ms(50);
					ResetButtonState(Button_Right,ST_LOCKED);
					main_menu_state = MAIN_MENU_STATE_MM2_WAIT;
					setpos(0,0);
					str_lcd(str1[0]); // 1 ,       
				}
				// 
				if(button_state[Button_Left]&ST_UNPRESSURE)
				{
					SetButtonState(Button_Left,ST_LOCKED);
					ResetButtonState(Button_Left,ST_UNPRESSURE);
					SetButtonState(Button_Left,ST_PRESSURE);
					//  
					_delay_ms(50);
					ResetButtonState(Button_Left,ST_LOCKED);
					main_menu_state = MAIN_MENU_STATE_EXIT_WAIT;
					setpos(0,0);
					str_lcd(str1[0]); // 1 ,       
				}
				// 
				if(button_state[Button_Down]&ST_UNPRESSURE)
				{
					SetButtonState(Button_Down,ST_LOCKED);
					ResetButtonState(Button_Down,ST_UNPRESSURE);
					SetButtonState(Button_Down,ST_PRESSURE);
					//  
					_delay_ms(50);
					ResetButtonState(Button_Down,ST_LOCKED);
					main_menu_state = MAIN_MENU_STATE_MM4_WAIT;
					setpos(0,0);
					str_lcd(str1[0]); // 1 ,       
				}
				// SELECT
				if(button_state[Button_Select]&ST_UNPRESSURE)
				{
					SetButtonState(Button_Select,ST_LOCKED);
					ResetButtonState(Button_Select,ST_UNPRESSURE);
					SetButtonState(Button_Select,ST_PRESSURE);
					//  
					_delay_ms(50);
					ResetButtonState(Button_Select,ST_LOCKED);
					main_menu_state = MAIN_MENU_STATE_MM1;
					setpos(0,0);
					str_lcd(str1[0]); // 1 ,       
				}
				break;
			case MAIN_MENU_STATE_MM2_WAIT: //  2 
				BlinkItem(1);
				// 
				if(button_state[Button_Right]&ST_UNPRESSURE)
				{
					SetButtonState(Button_Right,ST_LOCKED);
					ResetButtonState(Button_Right,ST_UNPRESSURE);
					SetButtonState(Button_Right,ST_PRESSURE);
					//  
					_delay_ms(50);
					ResetButtonState(Button_Right,ST_LOCKED);
					main_menu_state = MAIN_MENU_STATE_MM3_WAIT;
					setpos(5,0);
					str_lcd(str1[1]); // 2 ,       
				}
				// 
				if(button_state[Button_Left]&ST_UNPRESSURE)
				{
					SetButtonState(Button_Left,ST_LOCKED);
					ResetButtonState(Button_Left,ST_UNPRESSURE);
					SetButtonState(Button_Left,ST_PRESSURE);
					//  
					_delay_ms(50);
					ResetButtonState(Button_Left,ST_LOCKED);
					main_menu_state = MAIN_MENU_STATE_MM1_WAIT;
					setpos(5,0);
					str_lcd(str1[1]); // 2 ,       
				}
				// 
				if(button_state[Button_Down]&ST_UNPRESSURE)
				{
					SetButtonState(Button_Down,ST_LOCKED);
					ResetButtonState(Button_Down,ST_UNPRESSURE);
					SetButtonState(Button_Down,ST_PRESSURE);
					//  
					_delay_ms(50);
					ResetButtonState(Button_Down,ST_LOCKED);
					main_menu_state = MAIN_MENU_STATE_MM5_WAIT;
					setpos(5,0);
					str_lcd(str1[1]); // 2 ,       
				}
				// SELECT
				if(button_state[Button_Select]&ST_UNPRESSURE)
				{
					SetButtonState(Button_Select,ST_LOCKED);
					ResetButtonState(Button_Select,ST_UNPRESSURE);
					SetButtonState(Button_Select,ST_PRESSURE);
					//  
					_delay_ms(50);
					ResetButtonState(Button_Select,ST_LOCKED);
					main_menu_state = MAIN_MENU_STATE_MM2;
					setpos(5,0);
					str_lcd(str1[1]); // 2 ,       
				}
				break;
			case MAIN_MENU_STATE_MM3_WAIT: //  3 
				BlinkItem(2);
				// 
				if(button_state[Button_Right]&ST_UNPRESSURE)
				{
					SetButtonState(Button_Right,ST_LOCKED);
					ResetButtonState(Button_Right,ST_UNPRESSURE);
					SetButtonState(Button_Right,ST_PRESSURE);
					//  
					_delay_ms(50);
					ResetButtonState(Button_Right,ST_LOCKED);
					main_menu_state = MAIN_MENU_STATE_MM4_WAIT;
					setpos(10,0);
					str_lcd(str1[2]); // 3 ,       
				}
				// 
				if(button_state[Button_Left]&ST_UNPRESSURE)
				{
					SetButtonState(Button_Left,ST_LOCKED);
					ResetButtonState(Button_Left,ST_UNPRESSURE);
					SetButtonState(Button_Left,ST_PRESSURE);
					//  
					_delay_ms(50);
					ResetButtonState(Button_Left,ST_LOCKED);
					main_menu_state = MAIN_MENU_STATE_MM2_WAIT;
					setpos(10,0);
					str_lcd(str1[2]); // 3 ,       
				}
				// 
				if(button_state[Button_Down]&ST_UNPRESSURE)
				{
					SetButtonState(Button_Down,ST_LOCKED);
					ResetButtonState(Button_Down,ST_UNPRESSURE);
					SetButtonState(Button_Down,ST_PRESSURE);
					//  
					_delay_ms(50);
					ResetButtonState(Button_Down,ST_LOCKED);
					main_menu_state = MAIN_MENU_STATE_EXIT_WAIT;
					setpos(10,0);
					str_lcd(str1[2]); // 3 ,       
				}
				// SELECT
				if(button_state[Button_Select]&ST_UNPRESSURE)
				{
					SetButtonState(Button_Select,ST_LOCKED);
					ResetButtonState(Button_Select,ST_UNPRESSURE);
					SetButtonState(Button_Select,ST_PRESSURE);
					//  
					_delay_ms(50);
					ResetButtonState(Button_Select,ST_LOCKED);
					main_menu_state = MAIN_MENU_STATE_MM3;
					setpos(10,0);
					str_lcd(str1[2]); // 3 ,       
				}
				break;
			case MAIN_MENU_STATE_MM4_WAIT: //  4 
				BlinkItem(3);
				// 
				if(button_state[Button_Right]&ST_UNPRESSURE)
				{
					SetButtonState(Button_Right,ST_LOCKED);
					ResetButtonState(Button_Right,ST_UNPRESSURE);
					SetButtonState(Button_Right,ST_PRESSURE);
					//  
					_delay_ms(50);
					ResetButtonState(Button_Right,ST_LOCKED);
					main_menu_state = MAIN_MENU_STATE_MM5_WAIT;
					setpos(0,1);
					str_lcd(str1[3]); // 4 ,       
				}
				// 
				if(button_state[Button_Left]&ST_UNPRESSURE)
				{
					SetButtonState(Button_Left,ST_LOCKED);
					ResetButtonState(Button_Left,ST_UNPRESSURE);
					SetButtonState(Button_Left,ST_PRESSURE);
					//  
					_delay_ms(50);
					ResetButtonState(Button_Left,ST_LOCKED);
					main_menu_state = MAIN_MENU_STATE_MM3_WAIT;
					setpos(0,1);
					str_lcd(str1[3]); // 4 ,       
				}
				// 
				if(button_state[Button_Up]&ST_UNPRESSURE)
				{
					SetButtonState(Button_Up,ST_LOCKED);
					ResetButtonState(Button_Up,ST_UNPRESSURE);
					SetButtonState(Button_Up,ST_PRESSURE);
					//  
					_delay_ms(50);
					ResetButtonState(Button_Up,ST_LOCKED);
					main_menu_state = MAIN_MENU_STATE_MM1_WAIT;
					setpos(0,1);
					str_lcd(str1[3]); // 4 ,       
				}
				// SELECT
				if(button_state[Button_Select]&ST_UNPRESSURE)
				{
					SetButtonState(Button_Select,ST_LOCKED);
					ResetButtonState(Button_Select,ST_UNPRESSURE);
					SetButtonState(Button_Select,ST_PRESSURE);
					//  
					_delay_ms(50);
					ResetButtonState(Button_Select,ST_LOCKED);
					main_menu_state = MAIN_MENU_STATE_MM4;
					setpos(0,1);
					str_lcd(str1[3]); // 4 ,       
				}
				break;
				case MAIN_MENU_STATE_MM5_WAIT: //  5 
				BlinkItem(4);
				// 
				if(button_state[Button_Right]&ST_UNPRESSURE)
				{
					SetButtonState(Button_Right,ST_LOCKED);
					ResetButtonState(Button_Right,ST_UNPRESSURE);
					SetButtonState(Button_Right,ST_PRESSURE);
					//  
					_delay_ms(50);
					ResetButtonState(Button_Right,ST_LOCKED);
					main_menu_state = MAIN_MENU_STATE_EXIT_WAIT;
					setpos(5,1);
					str_lcd(str1[4]); // 5 ,       
				}
				// 
				if(button_state[Button_Left]&ST_UNPRESSURE)
				{
					SetButtonState(Button_Left,ST_LOCKED);
					ResetButtonState(Button_Left,ST_UNPRESSURE);
					SetButtonState(Button_Left,ST_PRESSURE);
					//  
					_delay_ms(50);
					ResetButtonState(Button_Left,ST_LOCKED);
					main_menu_state = MAIN_MENU_STATE_MM4_WAIT;
					setpos(5,1);
					str_lcd(str1[4]); // 5 ,       
				}
				// 
				if(button_state[Button_Up]&ST_UNPRESSURE)
				{
					SetButtonState(Button_Up,ST_LOCKED);
					ResetButtonState(Button_Up,ST_UNPRESSURE);
					SetButtonState(Button_Up,ST_PRESSURE);
					//  
					_delay_ms(50);
					ResetButtonState(Button_Up,ST_LOCKED);
					main_menu_state = MAIN_MENU_STATE_MM2_WAIT;
					setpos(5,1);
					str_lcd(str1[4]); // 5 ,       
				}
				// SELECT
				if(button_state[Button_Select]&ST_UNPRESSURE)
				{
					SetButtonState(Button_Select,ST_LOCKED);
					ResetButtonState(Button_Select,ST_UNPRESSURE);
					SetButtonState(Button_Select,ST_PRESSURE);
					//  
					_delay_ms(50);
					ResetButtonState(Button_Select,ST_LOCKED);
					main_menu_state = MAIN_MENU_STATE_MM5;
					setpos(5,1);
					str_lcd(str1[4]); // 5 ,       
				}
				break;
			case MAIN_MENU_STATE_EXIT_WAIT: //   EXIT
				BlinkItem(5);
				// 
				if(button_state[Button_Right]&ST_UNPRESSURE)
				{
					SetButtonState(Button_Right,ST_LOCKED);
					ResetButtonState(Button_Right,ST_UNPRESSURE);
					SetButtonState(Button_Right,ST_PRESSURE);
					//  
					_delay_ms(50);
					ResetButtonState(Button_Right,ST_LOCKED);
					main_menu_state = MAIN_MENU_STATE_MM1_WAIT;
					setpos(10,1);
					str_lcd(str1[5]); //  EXIT,       
				}
				// 
				if(button_state[Button_Left]&ST_UNPRESSURE)
				{
					SetButtonState(Button_Left,ST_LOCKED);
					ResetButtonState(Button_Left,ST_UNPRESSURE);
					SetButtonState(Button_Left,ST_PRESSURE);
					//  
					_delay_ms(50);
					ResetButtonState(Button_Left,ST_LOCKED);
					main_menu_state = MAIN_MENU_STATE_MM5_WAIT;
					setpos(10,1);
					str_lcd(str1[5]); //  EXIT,       
				}
				// 
				if(button_state[Button_Up]&ST_UNPRESSURE)
				{
					SetButtonState(Button_Up,ST_LOCKED);
					ResetButtonState(Button_Up,ST_UNPRESSURE);
					SetButtonState(Button_Up,ST_PRESSURE);
					//  
					_delay_ms(50);
					ResetButtonState(Button_Up,ST_LOCKED);
					main_menu_state = MAIN_MENU_STATE_MM3_WAIT;
					setpos(10,1);
					str_lcd(str1[5]); //  EXIT,       
				}
				// SELECT
				if(button_state[Button_Select]&ST_UNPRESSURE)
				{
					SetButtonState(Button_Select,ST_LOCKED);
					ResetButtonState(Button_Select,ST_UNPRESSURE);
					SetButtonState(Button_Select,ST_PRESSURE);
					//  
					_delay_ms(50);
					ResetButtonState(Button_Select,ST_LOCKED);
					main_menu_state = MAIN_MENU_STATE_EXIT;
					setpos(10,1);
					str_lcd(str1[5]); //  EXIT,       
				}
				break;
			case MAIN_MENU_STATE_MM1: //  1
				main_menu_state = MAIN_MENU_STATE_IDLE;
				MainMenuItemProcess(1);
				clearlcd();
				break;
			case MAIN_MENU_STATE_MM2: //  2
				main_menu_state = MAIN_MENU_STATE_IDLE;
				MainMenuItemProcess(2);
				clearlcd();
				break;
			case MAIN_MENU_STATE_MM3: //  3
				main_menu_state = MAIN_MENU_STATE_IDLE;
				MainMenuItemProcess(3);
				clearlcd();
				break;
			case MAIN_MENU_STATE_MM4: //  4
				main_menu_state = MAIN_MENU_STATE_IDLE;
				MainMenuItemProcess(4);
				clearlcd();
				break;
			case MAIN_MENU_STATE_MM5: //  5
				main_menu_state = MAIN_MENU_STATE_IDLE;
				MainMenuItemProcess(5);
				clearlcd();
				break;
			case MAIN_MENU_STATE_EXIT: //  EXIT
				menu_state = MENU_STATE_IDLE;
				return;
				break;
		}
	}
}
//-----------------------------------------------------
//  
void BlinkItem(unsigned char ind)
{
	if(ind<3) setpos(ind*5,0);
	else setpos((ind-3)*5,1);
	if(tim_cnt<500) str_lcd(str1[ind]);
	else str_lcd("    ");
}
//-----------------------------------------------------
//     
void MainMenuItemProcess(unsigned char ind)
{
	clearlcd();
	setpos(0,0);
	str_lcd("ITEM ");
	sprintf(str2,"%d",ind);
	str_lcd(str2);
	str_lcd("  Press");
	setpos(0,1);
	str_lcd("SELECT from exit");
	//  ,   
	switch (ind)
	{
		case 1:
		//- 1  
		break;
		case 2:
		//- 2  
		break;
		case 3:
		//- 3  
		break;
		case 4:
		//- 4  
		break;
		case 5:
		//- 5  
		break;
	}
	while (1)
	{
		if(button_state[Button_Select]&ST_UNPRESSURE)
		{
			clearlcd();
			SetButtonState(Button_Select,ST_LOCKED);
			ResetButtonState(Button_Select,ST_UNPRESSURE);
			SetButtonState(Button_Select,ST_PRESSURE);
			//  
			_delay_ms(50);
			ResetButtonState(Button_Select,ST_LOCKED);
			return;
		}
		_delay_ms(50);
	}
}
//-----------------------------------------------------
